bzoj 1689: [Usaco2005 Open] Muddy roads 泥泞的路

Posted lwq12138

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了bzoj 1689: [Usaco2005 Open] Muddy roads 泥泞的路相关的知识,希望对你有一定的参考价值。

1689: [Usaco2005 Open] Muddy roads 泥泞的路

Description

Farmer John has a problem: the dirt road from his farm to town has suffered in the recent rainstorms and now contains (1 <= N <= 10,000) mud pools. Farmer John has a collection of wooden planks of length L that he can use to bridge these mud pools. He can overlap planks and the ends do not need to be anchored on the ground. However, he must cover each pool completely. Given the mud pools, help FJ figure out the minimum number of planks he needs in order to completely cover all the mud pools.

    牧场里下了一场暴雨,泥泞道路上出现了许多水坑,约翰想用一批长度为L的木板将这些水坑盖住.    牧场里的道路可以看成一根数轴,每个水坑可以用数轴上的两个坐标表示,如(3,6)表示从3到6有一个长度为3的水坑.所有的水坑都是不重叠的,(3,6)和(6,9)可以出现在同一个输入数据中,因为它们是两个连续的水坑,但不重叠.
    请你帮助约翰计算最少要用多少块木板才能将所有水坑盖住

Input

* Line 1: Two space-separated integers: N and L * Lines 2..N+1: Line i+1 contains two space-separated integers: s_i and e_i (0 <= s_i < e_i <= 1,000,000,000) that specify the start and end points of a mud pool along the road. The mud pools will not overlap. These numbers specify points, so a mud pool from 35 to 39 can be covered by a single board of length 4. Mud pools at (3,6) and (6,9) are not considered to overlap.

    第1行有二个用空格隔开的整数N和L.其中1≤N≤10000,表示水坑总数.L为木板长度.
接下来的N行每行有二个用整数si和ei(0≤si<ei≤109),表示一个水坑的两个坐标.

Output

* Line 1: The miminum number of planks FJ needs to use.

    一个整数,表示约翰盖住所有水坑最少要用多少块长为L的木板.

Sample Input

3 3
1 6
13 17
8 12

Sample Output

5

HINT

技术分享

题解:

贪心,或者说就是模拟。

思路还是很显然的,我就不多说了,细节注意一下就行了。。

#include<stdio.h>
#include<iostream>
#include<algorithm>
using namespace std;
const int N=10005;
struct node
{
    int a,b;
}p[N];
int n,m,i,x,s,t,ans,k;
bool cmp(const node&x,const node&y)
{
    return x.a<y.a;
}
int main()
{
    scanf("%d%d",&n,&m);
    for(i=1;i<=n;i++)
        scanf("%d%d",&p[i].a,&p[i].b);
    sort(p+1,p+n+1,cmp);
    ans=0;k=1;
    x=p[1].a;
    while(k<=n)
    {
        s=0;
        if(x>=p[k].a)
        {
            while(x>=p[k].a&&k<=n) s=max(s,p[k].b),k++;
            if(s>x) t=(s-x-1)/m+1,ans+=t,x+=t*m;
        } else x=p[k].a;
    }
    cout<<ans;
    return 0;
}

 

 

以上是关于bzoj 1689: [Usaco2005 Open] Muddy roads 泥泞的路的主要内容,如果未能解决你的问题,请参考以下文章

[BZOJ1677][Usaco2005 Jan]Sumsets 求和

bzoj1754[Usaco2005 qua]Bull Math*

bzoj2023[Usaco2005 Nov]Ant Counting 数蚂蚁*&&bzoj1630[Usaco2007 Demo]Ant Counting*

bzoj 16801740 : [Usaco2005 Mar]Yogurt factory 贪心 双倍经验

bzoj1684[Usaco2005 Oct]Close Encounter*

[BZOJ1672][Usaco2005 Dec]Cleaning Shifts 清理牛棚